import mongoose from 'mongoose';

let Schema = mongoose.Schema;

let CrawlSessionSchema = new Schema({
  beginTime: {type: Date},
  endTime: {type: Date},
  name: {type: String},
  step: {type: Number},
  // YYYY-MM-DD
  day: {type: String},
  // 0: 进行中， 1：已结束
  status: {Number}
}, {
  collection: 'crawl_session',
  timestamps: true
});

class CrawlSessionClass {
  static async updateRecord(record) {
    const query = {url: record.url};
    const options = {upsert: true, setDefaultsOnInsert:true};
    let incObj = {tryCount: 1}
    if (!record.lastStatus) {
      incObj.errCount = 1;
    }
    record['$inc'] = incObj;
    record.lastTry = new Date();
    await CrawlSessionModel.update(query, record, options);
  }
}
CrawlSessionSchema.loadClass(CrawlSessionClass);

let CrawlSessionModel = mongoose.model('CrawlSession', CrawlSessionSchema);

export default CrawlSessionModel;
