import schedule from 'node-schedule';
import config from '../../config/config';
import dandanzan from '../sites/dandanzan';
import commonTask from '../sites/common';
import proxy from "../sites/proxy";

export default {
  scheduleUpdateAll() {
    schedule.scheduleJob(config.schedule.website, async () => {
      try {
        await dandanzan.run();
      } catch (err) {
        console.log('error execute dandanzan');
      }
    });
    schedule.scheduleJob(config.schedule.common, async () => {
      try {
        await commonTask.run();
      } catch (err) {
        console.log('error execute commonTask');
      }
    });
    console.log('已添加更新dandanzan电影的任务');
    schedule.scheduleJob(config.schedule.proxy, async () => {
      try {
        await proxy.run();
      } catch (err) {
        console.log('error execute proxy');
      }
    });
    console.log('已添加更proxy的定时任务');
  },
}
