import netUtil from '../utils/net.util';
import cheerio from 'cheerio';

// 0. https://www.23txt.com
const parseTxt23 = async () => {
  let header = {
    'accept': 'text/html',
  }
  const url = 'https://www.23txt.com/files/article/html/5/5986/20099474.html';
  try {
    let data = await netUtil.getData(url, header, 'gb2312')
    const $ = cheerio.load(data);
    const content = $('#content').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 1. https://www.qu.la
const parseQu = async () => {
  let header = {
    'accept': 'text/html',
  }
  const url = 'https://www.qu.la/book/101104//book/101104/5293260.html';
  try {
    let data = await netUtil.getData(url, header)
    const $ = cheerio.load(data);
    const content = $('#content').text().replace(/　　 　　 　　 　　/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 2. http://www.sjtxt.com
const parseSj = async () => {
  let header = {
    'accept': 'text/html',
  }
  const url = 'http://www.sjtxt.com/book/86928/27934319.html';
  try {
    let data = await netUtil.getData(url, header)
    const $ = cheerio.load(data);
    const content = $('#content1').text().replace(/\n\n/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 3. https://www.konlan.org
const parseKl = async () => {
  let header = {
    'accept': 'text/html',
  }
  const url = 'https://www.konlan.org/book/33/33029/8096245.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk')
    const $ = cheerio.load(data);
    const content = $('#contents').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 4. https://qxs.la
const parseQxs = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'https://quanxiaoshuo.com/222409/36102603/';
  url = url.replace('quanxiaoshuo.com', 'qxs.la');
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    $('#content div').remove();
    const content = $('#content').text().replace(/　　/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 5. http://www.qiuwu.net
const parseQiuwu = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.qiuwu.net/html/394/394752/120766537.shtml';
  url = url.replace('http://www.qiuwu.net', 'https://www.okdd.net');
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    $('#content div').remove();
    const content = $('#content').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 6. http://www.uuxs.net
const parseUuxs = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.uuxs.net/book/21/21089/7866450.html';
  url = url.replace('uuxs.net', 'uuxs.la');
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    const content = $('#BookText').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 7. https://www.snwx8.com
const parseSnwx = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'https://www.snwx8.com/book/386/386070/81031223.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    const content = $('#BookText').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}


// 8. http://www.wangshuge.com
const parseWsg = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.wangshuge.com/books/17/17635/4795649.html';
  try {
    let data = await netUtil.getData(url, header, 'utf8', true)
    const $ = cheerio.load(data);
    const content = $('#contents').text().replace(/\n\n/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 9. https://www.7kshu.com https://www.qksw.com
const parseKshu7 = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'https://www.7kshu.com/49/49162/18586347.html';
  url = url.replace('7kshu', 'qksw');
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    const content = $('#content').text().replace(/　　/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 10. http://www.166xs.com
const parseXs16 = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.166xs.com/xiaoshuo/115/115434/30944884.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    $('.Banner').remove();
    $('.Book_Hot').remove();
    const content = $('.Book_Text').text().replace(/    /g, '\r\n').replace(/\n\n/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 11. https://www.fpzw.com  http://www.2kxs.com/
const parseKxs2 = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'https://www.fpzw.com/xiaoshuo/111/111775/27193221.html';
  url = url.replace('2kxs.com', 'fpzw.com');
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    $('.top_book').remove();
    $('.Text a').remove();
    $('.Text font').remove();
    const content = $('.Text').text().replace(/    /g, '\r\n').replace(/\n\n/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}


// 12. http://www.5858xs.com
const parseXs5858 = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.5858xs.com/html/244/244293/30953988.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    $('#content fieldset').remove();
    const content = $('#content').text().replace(/\n\n/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 13. http://www.aoyuge.com
const parseAoyuge = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.aoyuge.com/12/12653/5907171.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    const content = $('#BookText').text().replace(/\n\n/g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 14. http://www.x23us.com
const parseUs23 = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.x23us.com/html/68/68553/29426615.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    const content = $('#contents').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}


// 15. http://zuiyidu.com
const parseZyd = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://zuiyidu.com/sk/read.php?bid=2719&cid=150531';
  try {
    let data = await netUtil.getData(url, header)
    const $ = cheerio.load(data);
    const content = $('#kz_content').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 16. http://www.maopuzw.com
const parseMpzw = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://www.maopuzw.com/html/99/99322/19303607.html';
  try {
    let data = await netUtil.getData(url, header, 'gbk', true)
    const $ = cheerio.load(data);
    const content = $('#clickeye_content').text().replace(/    /g, '\r\n');
    console.log(content);
  } catch (err) {
    console.log(err);
  }
}

// 17. http://source.xiaoshuosousuo.com
const parseXsss = async () => {
  let header = {
    'accept': 'text/html',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36'
  }
  let url = 'http://source.xiaoshuosousuo.com/api.php?appid=1230100839&a=readChapterContent&bookid=3279&cid=118113';
  try {
    let data = await netUtil.getData(url, header)
    console.log(data);
  } catch (err) {
    console.log(err);
  }
}

export default {
  parseTxt23: parseTxt23,
  parseQu: parseQu,
  parseSj: parseSj,
  parseKl: parseKl,
  parseQxs: parseQxs,
  parseQiuwu: parseQiuwu,
  parseUuxs: parseUuxs,
  parseSnwx: parseSnwx,
  run: () => {
    parseXsss();
  }
}
