import CrawlRecord from '../models/spider/CrawlRecord';
import generalQueue from '../utils/general.queue';

/**
 * 获取抓取记录中 lastStatus = false的记录，再次抓取
 * */

const parseOneRecord = async function (record) {
  let classTask = require(`./${record.className}`).default;
  if(typeof classTask[record.methodName] === 'function'){
    try {
      generalQueue.addQueue({
        run: async function () {
          await classTask[record.methodName](record.params);
        }
      })
    } catch (err) {
      console.log('error parse false record', record.id);
    }
  }

}

const parseAllRecord = async function () {
  console.log('begin parse all false record');
  let records;
  try {
    records = await CrawlRecord.find({lastStatus: false});
  } catch (err) {
    console.log('error get records');
  }
  return new Promise(async (resolve, reject) => {
    console.time('all')
    generalQueue.setCb(function () {
      console.log('parse all false records finished');
      resolve()
    })
    if (records) {
      for(const record of records) {
        try {
          await parseOneRecord(record);
        } catch (err) {
          console.log('error parse record:', record);
        }
      }
    }
  });
}

export default {
  run: async () => {
    await parseAllRecord();
    await parseAllRecord();
  }
}
