import SpiderData from '../models/SpiderData';
import Movie from '../models/Movies';
const typeArr = ['科幻片','喜剧片', '剧情片','动作片','动漫','恐怖片','爱情片','动画片','悬疑片','战争片'];

// 将下载的电影导入到正式表中
const parseAllMovie = async () => {
  try {
    let list = await SpiderData.find({type: 'movie'});
    for (let obj of list) {
      let data = obj.data;
      let typeIdx = typeArr.indexOf(data.type) + 1;
      let resourceStr = data.playResourceUrl;
      let arr = resourceStr.replace(/\$\$\$/g, '#').split('#');
      let resourceArr = [];
      for (let str of arr) {
        resourceArr.push({
          title: str.substring(0, str.indexOf('$')),
          link: str.substring(str.indexOf('$') + 1)
        })
      }
      let record = new Movie({
        gid: data.id,
        name: data.name,
        type: typeIdx,
        score: data.grade,
        introduce: data.introduce,
        language: data.language,
        img: data.img,
        daoYan: data.daoYan,
        zhuYan: data.zhuYan,
        region: data.region,
        year: data.releaseDate,
        sortIdx: 0,
        price: 10,
        resources: resourceArr
      });
      await record.save();
    }
  } catch (err) {
    console.log(err);
  }
}
// 移除电影中不可播放的链接
const removeErrorMovieLink = async () => {
  try {
    let records = await Movie.find({});
    for (let record of records) {
      let links = [];
      for(let link of record.resources) {
        if (link.link.toLowerCase().startsWith('http')) {
          links.push(link);
        }
      }
      record.resources = links;
      record.markModified('resources');
      record.save();
    }
    console.log('all done');
  } catch (err) {
    console.log(err);
  }
}
export default {
  run: async () => {
    try {
      // parseAllMovie();
      removeErrorMovieLink();
    } catch (err) {
      console.log(err);
    }

  }
}
