import config from '../../config/config';
import fs from 'fs';
import request from 'request';
import async from 'async';
import dateformat from 'dateformat';
import mkdirp from 'mkdirp';
import logger from '../utils/logger';


/**
 * 文件下载队列
 * */
let q = async.queue(function (file, cb) {
  let local_path = `${config.download_path}/${dateformat('yyyymmdd')}/${file.type}`;
  if (!fs.existsSync(local_path)){
    mkdirp.sync(local_path);
  }
  if (file.name) {
    local_path = local_path + '/' + file.name;
  }
  if (fs.existsSync(local_path)) {
    return cb()
  }
  let stream = request
    .get({
      url: file.url,
      timeout: 1000
    })
    .on('response', function(response) {

    })
    .on('error', function(err) {
      cb(err);
    })
    .pipe(fs.createWriteStream(local_path));
  stream.on('finish',() => {
    console.info(file, 'file download success');
    cb()
  })
}, 2);
q.drain = function(){
  console.info('all queue done');
};
module.exports = {
  add_file_queue(file) {
    console.log('add file to queue', file);
    q.push(file, function(err){
      if (err) {
        console.log('error download file: ', file.url, err);
      }
    });
  }
}
